#ifndef TRAINSYSTEM_H
#define TRAINSYSTEM_H

#include <zeitgeist/node.h>
#include "trainserver.h"

class TrainSystem : public zeitgeist::Node
{
public:
    TrainSystem();
    
    virtual ~TrainSystem();
    
    virtual bool Init()     = 0;
    
    virtual void Update()   = 0;

    virtual void Reset()   = 0; //also will be called when training system reset the time
protected:
    void OnLink();
    
    void OnUnlink();
    
protected:
    /** cached reference to TrainServer */
    CachedPath<TrainServer> mTrainServer;
};

DECLARE_ABSTRACTCLASS(TrainSystem);

#endif

