#ifndef NETWORK_H
#define NETWORK_H

#include <string>
#include <iostream>
#include <rcssnet/tcpsocket.hpp>
#include <rcssnet/exception.hpp>
#include <zeitgeist/node.h> // #include <zeitgeist/leaf.h> error: expected constructor...
#ifndef WIN32
#include <arpa/inet.h>
#endif

class Network : public zeitgeist::Leaf
{
public:
    Network();

    ~Network();
    
    bool Init();
    
    void Done();
    
    bool GetMessage(std::string& msg);
    
    bool PutMessage(const std::string& msg);
    
    bool SelectInput();
    
    void SetServer(std::string host) { mHost = host; }
    
    void SetPort(int port) { mPort = port; }
    
protected:
    void OnLink();
    
    void OnUnLink();

private:
    rcss::net::TCPSocket     mSocket;
    
    std::string  mHost;
    
    int          mPort;
};

DECLARE_CLASS(Network);

#endif
