#ifndef SPLINE_H
#define SPLINE_H

/** spline interpolation from book "Numerical Recipes in C"
    array [] start from 1 (not 0)
    and please make sure that m_x[1] < m_x[2] < m_x[3] < ...
*/
class Spline
{
public:
    Spline();
    ~Spline();

    Spline(float* x, float* y, int n);

    void SetBreakPoints(float* x, float* y, int n,
                        float yp1 = 0.0, float ypn = 0.0);

    bool General();

    float GetYGivenX(float x, int der = 0) const;

private:
    float* m_x;

    float* m_y;

    float* m_y2;

    float m_yp1;

    float m_ypn;

    int m_n;
};

#endif
